#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

PROCEDURE Appsys
RETURN

PROCEDURE Main
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg

   oDlg := SLE8Dlg():New()

   oDlg:DrawingArea:DropZone  := .T.
   oDlg:DrawingArea:DragEnter := { | aState, oData | oDlg:HandleDragEnter( aState, oData ) }
   oDlg:DrawingArea:DragLeave := { | aState, uNIL  | oDlg:HandleDragLeave( aState, ) }
   oDlg:DrawingArea:DragDrop  := { | aState, oData | oDlg:HandleDragDrop( aState, oData, oDlg ) }

   oDlg:Create()

   CenterControl(oDlg)
   oDlg:show()

   SetAppFocus(oDlg)

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

RETURN

CLASS SLE8form FROM XbpDialog
   EXPORTED:
      VAR editControls

      * Enthaltene Kontrollelemente
      VAR oGrp
      VAR oSLE1
      VAR oSLE2
      VAR oSLE3
      VAR oSLE4
      VAR oSLE5
      VAR oSLE6
      VAR oSLE7
      VAR oSLE8
      VAR ButtonCancel
      VAR ButtonOK

      METHOD init
      METHOD create
ENDCLASS

METHOD SLE8form:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {1,3}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {254+50,367}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {238+50,333}
   ENDIF
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "8 Zeilen a 25 Zeichen per Copy / Paste ?"

   ::editControls := {}

   ::oGrp         := XbpStatic():new( ::drawingArea, , {16,92}, {208+50,240}, { { XBP_PP_BGCLR, -255 } } )
   ::oGrp:caption := ""
   ::oGrp:clipSiblings := .T.
   ::oGrp:type := XBPSTATIC_TYPE_GROUPBOX

   ::oSLE1        := XbpSLE():new( ::oGrp, , {4,200}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
*   ::oSLE1:autoTab := .T.
   ::oSLE1:bufferLength := 26
   ::oSLE1:tabStop := .T.

   ::oSLE2        := XbpSLE():new( ::oGrp, , {4,172}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
*   ::oSLE2:autoTab := .T.
   ::oSLE2:bufferLength := 26
   ::oSLE2:tabStop := .T.

   ::oSLE3        := XbpSLE():new( ::oGrp, , {4,144}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
*   ::oSLE3:autoTab := .T.
   ::oSLE3:bufferLength := 26
   ::oSLE3:tabStop := .T.

   ::oSLE4        := XbpSLE():new( ::oGrp, , {4,116}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
*   ::oSLE4:autoTab := .T.
   ::oSLE4:bufferLength := 26
   ::oSLE4:tabStop := .T.

   ::oSLE5        := XbpSLE():new( ::oGrp, , {4, 88}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
*   ::oSLE5:autoTab := .T.
   ::oSLE5:bufferLength := 26
   ::oSLE5:tabStop := .T.

   ::oSLE6        := XbpSLE():new( ::oGrp, , {4, 60}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
*   ::oSLE6:autoTab := .T.
   ::oSLE6:bufferLength := 26
   ::oSLE6:tabStop := .T.

   ::oSLE7        := XbpSLE():new( ::oGrp, , {4, 32}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
*   ::oSLE7:autoTab := .T.
   ::oSLE7:bufferLength := 26
   ::oSLE7:tabStop := .T.

   ::oSLE8        := XbpSLE():new( ::oGrp, , {4,  4}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
*   ::oSLE8:autoTab := .T.
   ::oSLE8:bufferLength := 26
   ::oSLE8:tabStop := .T.

   ::ButtonCancel := XbpPushButton():new( ::drawingArea, , {16,16}, {64,64}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::ButtonCancel:caption := "Abbruch"
   ::ButtonCancel:tabStop := .T.
   ::ButtonCancel:activate := {|| PostAppEvent( xbeP_Close ) }

   ::ButtonOK     := XbpPushButton():new( ::drawingArea, , {156+50,16}, {64,64}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::ButtonOK:caption := "Ok"
   ::ButtonOK:tabStop := .T.
   ::ButtonOK:activate := {|| Gather( ::editControls ), PostAppEvent( xbeP_Close ) }


   AADD(::editControls,::oSLE1)
   AADD(::editControls,::oSLE2)
   AADD(::editControls,::oSLE3)
   AADD(::editControls,::oSLE4)
   AADD(::editControls,::oSLE5)
   AADD(::editControls,::oSLE6)
   AADD(::editControls,::oSLE7)
   AADD(::editControls,::oSLE8)

RETURN self

METHOD SLE8form:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oGrp:create()
   ::oSLE1:create()
   ::oSLE2:create()
   ::oSLE3:create()
   ::oSLE4:create()
   ::oSLE5:create()
   ::oSLE6:create()
   ::oSLE7:create()
   ::oSLE8:create()

   ::ButtonCancel:create()
   ::ButtonOK:create()

RETURN self

CLASS SLE8Dlg FROM SLE8form
   EXPORTED:
      METHOD init
      METHOD create

      METHOD HandleDragEnter()
      METHOD HandleDragLeave()
      METHOD HandleDragDrop()

ENDCLASS

METHOD SLE8Dlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::SLE8form:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD SLE8Dlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::SLE8form:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self


METHOD SLE8Dlg:HandleDragEnter( aState, oData )

   IF oData:QueryGetFormat( XBPCLPBRD_TEXT ) == .T.
      RETURN XBP_DROPMODE_COPY
   ENDIF
RETURN XBP_DROPMODE_NONE

METHOD SLE8Dlg:HandleDragLeave( aState, oData )

RETURN NIL

METHOD SLE8Dlg:HandleDragDrop( aState, oData, oParent )

LOCAL cText := oData:GetData( XBPCLPBRD_TEXT )
LOCAL i
LOCAL iMax  := LEN( ::editControls )
LOCAL cLine := ""
LOCAL nPos  := 1

ALTD()

   FOR i := 1 TO iMax
      cLine := SUBSTR(cText,nPos,26)
      ::editControls[i]:setdata(cLine)

      cText := STRTRAN(cText,cLine,"")
      IF EMPTY(cText)
         EXIT
      ENDIF

   NEXT

RETURN XBP_DROPMODE_COPY

//EOF
/////